# Service account to run elastic search.
apiVersion: v1
kind: ServiceAccount
metadata:
  name: wikipoc
---
# Service to expose and loadbalance between pods.
apiVersion: v1
kind: Service
metadata:
  name: wikipoc
spec:
  selector:
    app: wikipoc
  ports:
    - protocol: TCP
      port: 8000
      targetPort: 8000
---
# Deployment to create necessary pods with configurations.
apiVersion: apps/v1
kind: Deployment
metadata:
  name: wikipoc
  labels:
    app: wikipoc
spec:
  replicas: 1
  selector:
    matchLabels:
      app: wikipoc
  template:
    metadata:
      labels:
        app: wikipoc
    spec:
      # Pod to launch the service.
      serviceAccountName: wikipoc
      securityContext:
          # Your app shall always run as nonroot.
          runAsNonRoot: true
      affinity:
        # Avoid to run many pods on same physical node. It increases reliability.
        podAntiAffinity:
          preferredDuringSchedulingIgnoredDuringExecution:
          - weight: 1
            podAffinityTerm:
              labelSelector:
                matchLabels:
                  app: wikipoc
              topologyKey: kubernetes.io/hostname
      containers:
      - name: wiki
        image: registry.gitlab.com/arbetsformedlingen/wikipoc-gemensam-k-lla/frontend/wikipoc/main:latest
        imagePullPolicy: Always
        volumeMounts:
        - name: emptydir
          mountPath: /.npm
        ports:
        - containerPort: 8000
        securityContext:
          readOnlyRootFilesystem: true
        resources:
          limits:
            memory: "256Mi"
          requests:
            memory: "256Mi"
      volumes:
      - name: emptydir
        emptyDir: {}

